#!/usr/bin/perl -w 

sub usage(){
    print STDERR "Usage: $0 <src host>[:<port>] \n";
    print STDERR " Stop Tx of sudp_send2. \n";
    print STDERR "  src host port: default=9902. \n";
    print STDERR "  destination host dataport: default=9901. \n";
    exit(1);
}

# use Exporter;
use IO::Socket;                   # IO::Socket ⥸塼Ȥ
use lib "$ENV{HOME}/prog/perl/module";


my @cmds= qw/"in2net=connect:192.42.120.66" "mode=ext:0xff:1" "play_rate=data:08" "net_protocol=UDP:3200000:10" "in2net=on"/;

my $cnt=0;
{
    usage() if(@ARGV <1);
    my $srcport = 9902;
    my @terms = split(/:/,shift);
    my $srchost = $terms[0];
    $srcport = $terms[1]  if(@terms > 1);

    my $remote = IO::Socket::INET->new(Proto    => "tcp",
				       PeerAddr => $srchost,
				       PeerPort => $srcport );
    
    if( ! $remote){	die "Could not connect to $srchost:$srcport \n";    }

    select($remote); $|=1; # stop buffering 
    select(STDIN); $|=1; # stop buffering 
    select(STDOUT); $|=1; # stop buffering 

    ## Set Destination host
    my $msg = "in2net=off;";
    &communicate($remote,"$msg\n");
    close $remote;
}

sub communicate($$){
    my $socket = shift;
    my $line = shift;

    last unless(defined($socket));
    print $socket $line;
    last unless(defined($socket));
    
    my $res = <$socket>;
    next unless(defined($res));
    chomp($res);
    print STDERR "Res[$cnt]: $res\n" if(defined($res));
    $cnt++;
    
}
