/** 
 * @Version $Rev: 56 $
 * @Author M.Sekido
 * @Date  $Date: 2013-07-03 20:40:14 +0900 (水, 03  7月 2013) $
 * $Id: Trans_info.cpp 56 2013-07-03 11:40:14Z vlbi $ 
 */

#include "Trans_info.hpp"

/** Constructor */
TransInfo::TransInfo(const ApplProtocol_t apt, const TransProtocol_t tpt ):
  mtu(DEFAULT_MTU_SIZE),speed(2000000),data_port(DEFAULT_DATA_PORT),
  transLayerProtocol(tpt),
  applLayerProtocol(apt),applProtocolState(IDLE),txrx_length(-1),
  EndEpoch(0), opr_mode(TX),useTransSpeed(false)
{
  ;
}

TransInfo::TransInfo(const int m):
  mtu(m),speed(2000000),data_port(DEFAULT_DATA_PORT),
  transLayerProtocol(UDP_IO),
  applLayerProtocol(SUDP_Proto),applProtocolState(IDLE),txrx_length(-1),
  EndEpoch(0), opr_mode(TX),useTransSpeed(false)
{
  ;
}

string TransInfo::TransProtocolStr(){
  string str;
  switch (transLayerProtocol){
  case UDP_IO: str = "UDP"; return str; break;
  case TCP_IO: str = "TCP"; return str; break;
  case FILE_IO: str = "FILE"; return str; break;
  default: str = "NotYetSet";return str; break;
  }
}

string TransInfo::Status(){
  string ret;
  switch(applProtocolState){
  case IDLE:
    ret = "IDLE"; break;
  case RXING:
    ret = "Receiviing";  break;
  case TXING:
    ret = "Sending";  break;
  case STOP:
    ret = "STOP Requested";  break;
  case RX_READY:
    ret = "RX Ready";  break;
  case TX_READY:
    ret = "TX Ready";  break;
  }
  return ret;
}

int TransInfo::Set_mtu(const int m){
  if( m < 0 ){
    cerr << "Error in TransInfo::Set_mtu(): mtu(" << m << ") is negative"
	 << endl;
    return -1;
  }
  mtu = m;
  return 0;
}
