/** 
 * @Version $Rev: 56 $
 * @Author M.Sekido
 * @Date  $Date: 2013-07-03 20:40:14 +0900 (水, 03  7月 2013) $
 * $Id: VDIF_Proto.cpp 56 2013-07-03 11:40:14Z vlbi $ 
 */

#include "VDIF_Proto.hpp"

/// Check the readiness of data transmission.

// int VDIF_Proto::Ready(VLBI_Frame *vf){
//   if( VLBI_Proto::Ready(vf) <0 ){ 
//     cerr << "Error in VLBI_Proto::Ready(): VLBI_Proto::Ready() failed\n"; 
//     return -1;  };
//   //  dat.resize(speed*4);
//   return 0;
// }

int32_t VDIF_Proto::TX1sec(time_t t1, vector <uint8_t>& arr, const int32_t ndat){
  if(_sock==0){
    cerr << "Error in VLBI_Proto::TX(): Socket is not ready\n";
    return -1;
  }
  ssize_t nwrote;

  vlbi_frame->Set_Epoch(t1);
  int packetsize = vlbi_frame->Framesize();
  int hdr_size = VDIF_Hdr_size;
  //  uint32_t byte_sec = vlbi_frame->DAS_inf().Byte_sec();
  //  uint32_t remain = byte_sec + offset;
  int32_t remain = ndat;
  int pldsize = packetsize - hdr_size;
  uint16_t npkt = remain/pldsize;
  int32_t  tot(0);
  uint32_t index=0;
  //  while (remain >=  pldsize )  {
  //  gettimeofday(&st,NULL);
  /// Loop for 1 sec
  for(uint32_t ipkt=0; ipkt<npkt; ipkt++){
    
    //      mark5header((unsigned int *)&dat[offset],device_epoch-2,
    //		  (double)block/speed,iframe);

    int ret = vlbi_frame->Set_header(&packet[0],ipkt);
    if(ret != hdr_size){
      fprintf(stderr,"Error in VDIF_Proto::TX(): vlbi_frame->Set_header() = %d != VDIF header(%d)\n",
	      ret, hdr_size);
      return -1;
    }
      
    memcpy(&packet[hdr_size], &arr[index],  pldsize);
    remain -= pldsize; index += pldsize;
    switch(trans_prot_type){
    case UDP_IO:
      //      nwrote = _udpsock->sendto((struct sockaddr&)addr, sizeof(addr), (char*)&packet[0],packetsize);
      nwrote = _sock->sendto((struct sockaddr*)&addr, sizeof(addr), (char*)&packet[0],packetsize);
      break;
    case TCP_IO:
      nwrote = _sock->send(&packet[0], packetsize);break;
    case FILE_IO:
      nwrote = _sock->send(&packet[0], packetsize);break;
    default:	  
      cerr << "Error in VDIF_Proto::TX(): wrong trans_proto_type specified\n";
      cerr << "\tTrans_prot_type is supported only for TCP/UDP/FILE.\n";
      return -1;
    }

    if (nwrote==-1) {
      perror("Sending packet");
      //	  Set_Idle();
      //	  exit(1);
      break; 
    } else if (nwrote==-2) {
      cerr << "Error in K5_VSI_SENDER::Send_Mk5(): unreceverable error\n";
      return (-2);
    } else if (nwrote==0) {
      fprintf(stderr, "Warning: Did not write any bytes!\n");
      //  Set_Idle();
      //	  return -1;
      break; continue;
      continue;
    } else if (nwrote!=packetsize) {
      fprintf(stderr, "Warning: Did not write all bytes!\n");
      //	  Set_Idle();
      //	  return -1;
      tot+=nwrote;
      continue;
    }   
    tot+=nwrote;

    /// Adjusting rate sometimes
//     if(ipkt % 100 == 0){
//       gettimeofday(&et,NULL);
//       //      wait=(0.99*block)/speed
//       double dt = (et.tv_sec-st.tv_sec)+0.000001*(et.tv_usec-st.tv_usec);
//       wait=(double)net_tot*0.25/speed;
//       wait -= dt;
//       if(wait>0.00001){
// 	usleep((uint32_t)(1000000*wait));
// 	//	fprintf(stderr,"Sleep %e sec\n",wait);
//       }
//     }
      
  } // Loop for all data 
    
  memmove(&arr[0],&arr[index],remain);   
  if(remain > pldsize){
    fprintf(stderr, "Error in VDIF_Prot::TX(): remian(%d) > pldsize(%d),",
	    remain, pldsize);
    fprintf(stderr,"Wrong computation.");
    exit(1);
  }
  offset = remain;      
  //  gettimeofday(&et,NULL);
  //  double dt = (et.tv_sec-st.tv_sec)+0.000001*(et.tv_usec-st.tv_usec);
  //  tx_rate = 0.000001*(8.*tot)/dt;  // (Mbps)
  //  sent_Mbytes+=tot*1.e-6;  // (Bytes)

  //    tot=0;
  //free(raw_data);
  //    munmap( raw_data,sizeof(unsigned int)*page_length);
  //    length--;
  //    data_epoch++;
  //     wait= (double)data_epoch+1 - et.tv_sec - 0.000001*et.tv_usec;
  //     //    fprintf(stderr,"Wait %lf sec\n", wait);
  //     if(wait>0.00001){
  //       usleep((uint32_t)(1000000*wait));
  //       //      fprintf(stderr,"Sleep %lf sec\n", wait);
  //     }

  
  return ndat-remain;
    
}
