/** 
 * @Version $Rev: 56 $
 * @Author M.Sekido
 * @Date  $Date: 2013-07-03 20:40:14 +0900 (水, 03  7月 2013) $
 * $Id: conf-test.cpp 56 2013-07-03 11:40:14Z vlbi $ 
 */

#include <iostream>

using namespace std;

#include "conf_utl.hpp"
extern "C"{
  #include <sys/types.h>
  #include <unistd.h>
}


char *me;
void usage(){
  printf("Usage: %s -c <conf file> [-f <file>]\n",me);
  printf(" Test reading of the config file\n"); 
  printf(" -f: the file to be change the ownership.\n"); 
  exit(1);
}

int main(int argc, char* argv[]){
  me = (me = strrchr(argv[0], '/')) == NULL ? argv[0] : me+1; /* My name */ 
  int k=0;
  std::string conf_file, targetf;
  while (k >= 0) { 
    switch (k = getopt(argc, argv, "hc:f:")) { 
    case 'c':     conf_file = optarg;     break;
    case 'f':     targetf = optarg;     break;
    case 'h':   
    case '?':    usage(); break;
    }
  }

  if(conf_file.empty()) usage();
  
  std::map <std::string, std::string> list1;

  list1["test1"] = "good";
  std::map <std::string, std::string>::iterator itr = list1.begin();
  printf("size of list1 = %lu \n", (ulong)list1.size());
  while(itr != list1.end()){
    printf("list[%s] = %s\n", itr->first.c_str(), itr->first.c_str());
    itr++;
  }
  
  Config_set conf;
  conf.Read(conf_file.c_str());
  conf.Print();
  printf("conf[Owner] = %s\n", conf.Value("Owner").c_str());
  cerr << "Check_Key(Owner)=" << conf.Check_Key("Owner") << endl;
  cerr << "Check_Key(Group)=" << conf.Check_Key("Group") << endl;
  
  uid_t uid = atoi(conf.Value("Owner").c_str());
  gid_t gid = atoi(conf.Value("Group").c_str());
  
  if(! targetf.empty()){
    if(chown(targetf.c_str(), uid, gid) ==0){
      fprintf(stderr,"Chown successed.\n");
    }else{
      fprintf(stderr,"Chown Failed.\n");
    }

  }

}
